gKit2 light

- Main Page
- Related Pages
- Modules
- Classes
- Files

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Protected Attributes | List of all members
TP Class Reference
Inheritance diagram for TP:

## Public Member Functions
int | init ()
| a deriver pour creer les objets openGL. More...
int | quit ()
| a deriver pour detruire les objets openGL. More...
int | render ()
| a deriver pour afficher les objets. More...
int | init ()
| a deriver pour creer les objets openGL. More...
int | quit ()
| a deriver pour detruire les objets openGL. More...
int | update (const float time, const float delta)
| a deriver et redefinir pour animer les objets en fonction du temps. More...
int | render ()
| a deriver pour afficher les objets. More...
int | init ()
| a deriver pour creer les objets openGL. More...
int | quit ()
| a deriver pour detruire les objets openGL. More...
int | update (const float time, const float delta)
| a deriver et redefinir pour animer les objets en fonction du temps. More...
int | render ()
| a deriver pour afficher les objets. More...
int | init ()
| a deriver pour creer les objets openGL. More...
int | quit ()
| a deriver pour detruire les objets openGL. More...
int | update (const float time, const float delta)
| a deriver et redefinir pour animer les objets en fonction du temps. More...
int | render ()
| a deriver pour afficher les objets. More...
int | init ()
| a deriver pour creer les objets openGL. More...
int | quit ()
| a deriver pour detruire les objets openGL. More...
int | update (const float time, const float delta)
| a deriver et redefinir pour animer les objets en fonction du temps. More...
int | render ()
| a deriver pour afficher les objets. More...
Public Member Functions inherited from App
| App (const int width, const int height, const int major=3, const int minor=3)
| constructeur, dimensions de la fenetre et version d'openGL. More...
int | run ()
| execution de l'application. More...
float | global_time ()
| renvoie le temps ecoule depuis le lancement de l'application, en millisecondes. More...
float | delta_time ()
| renvoie le temps ecoule depuis la derniere frame, en millisecondes. More...

## Protected Attributes
Mesh | m_objet
GLuint | m_texture
Orbiter | m_camera
Transform | m_model
Mesh | m_frustum
Mesh | m_grid
Orbiter | m_observer
Point | m_pmin
Point | m_pmax
GLuint | m_indirect_buffer
GLuint | m_model_buffer
GLuint | m_time_query
GLuint | m_vao
GLuint | m_program
Text | m_console
GLuint | m_vertex_buffer
unsigned int | m_vertex_count
Protected Attributes inherited from App
Window | m_window
Context | m_context
unsigned int | m_time
unsigned int | m_delta

## Detailed Description

Definition at line 12 of file tuto7.cpp.

## Member Function Documentation

int TP::init | ( |  | ) |
| inline virtual

a deriver pour creer les objets openGL.

Implements App.

Definition at line 19 of file tuto7.cpp.

20 {
21 m_objet= read_mesh("data/cube.obj");
22
23 Point pmin, pmax;
24 m_objet.bounds(pmin, pmax);
25 m_camera.lookat(pmin, pmax);
26
27 m_texture= read_texture(0, "data/debug2x2red.png");
28
29 // etat openGL par defaut
30 glClearColor(0.2f, 0.2f, 0.2f, 1.f); // couleur par defaut de la fenetre
31
32 glClearDepth(1.f); // profondeur par defaut
33 glDepthFunc(GL_LESS); // ztest, conserver l'intersection la plus proche de la camera
34 glEnable(GL_DEPTH_TEST); // activer le ztest
35
36 return 0; // ras, pas d'erreur
37 }
Mesh::bounds
void bounds(Point &pmin, Point &pmax)
renvoie min et max les coordonnees des extremites des positions des sommets de l'objet (boite engloba...
Definition: mesh.cpp:153
read_texture
GLuint read_texture(const int unit, const char *filename, const GLenum texel_type)
Definition: texture.cpp:98
Orbiter::lookat
void lookat(const Point &center, const float size)
observe le point center a une distance size.
Definition: orbiter.cpp:7
Point
representation d'un point 3d.
Definition: vec.h:19
read_mesh
Mesh read_mesh(const char *filename)
charge un fichier wavefront .obj et renvoie un mesh compose de triangles non indexes. utiliser glDrawArrays pour l'afficher. a detruire avec Mesh::release( ).
Definition: wavefront.cpp:8

int TP::quit | ( |  | ) |
| inline virtual

a deriver pour detruire les objets openGL.

Implements App.

Definition at line 40 of file tuto7.cpp.

41 {
42 m_objet.release();
43 glDeleteTextures(1, &m_texture);
44
45 return 0;
46 }
Mesh::release
void release()
detruit les objets openGL.
Definition: mesh.cpp:19

int TP::render | ( |  | ) |
| inline virtual

a deriver pour afficher les objets.

Implements App.

Definition at line 49 of file tuto7.cpp.

50 {
51 glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
52
53 // deplace la camera
54 int mx, my;
55 unsigned int mb= SDL_GetRelativeMouseState(&mx, &my);
56 if(mb & SDL_BUTTON(1)) // le bouton gauche est enfonce
57 m_camera.rotation(mx, my);
58 else if(mb & SDL_BUTTON(3)) // le bouton droit est enfonce
59 m_camera.move(mx);
60 else if(mb & SDL_BUTTON(2)) // le bouton du milieu est enfonce
61 m_camera.translation((float) mx / (float) window_width(), (float) my / (float) window_height());
62
63 draw(m_objet, m_camera, m_texture);
64
65 return 1;
66 }
Orbiter::move
void move(const float z)
rapproche / eloigne la camera du centre.
Definition: orbiter.cpp:33
draw
void draw(Mesh &m, const Transform &model, const Transform &view, const Transform &projection, const GLuint texture)
applique une texture a la surface de l'objet. ne fonctionne que si les coordonnees de textures sont f...
Definition: draw.cpp:6
window_width
int window_width()
renvoie la largeur de la fenetre de l'application.
Definition: window.cpp:14
Orbiter::translation
void translation(const float x, const float y)
deplace le centre / le point observe.
Definition: orbiter.cpp:27
Orbiter::rotation
void rotation(const float x, const float y)
change le point de vue / la direction d'observation.
Definition: orbiter.cpp:21
window_height
int window_height()
renvoie la hauteur de la fenetre de l'application.
Definition: window.cpp:18

int TP::init | ( |  | ) |
| inline virtual

a deriver pour creer les objets openGL.

Implements App.

Definition at line 19 of file tuto8.cpp.

20 {
21 m_objet= read_mesh("data/cube.obj");
22
23 Point pmin, pmax;
24 m_objet.bounds(pmin, pmax);
25 m_camera.lookat(pmin, pmax);
26
27 m_texture= read_texture(0, "data/debug2x2red.png");
28
29 // etat openGL par defaut
30 glClearColor(0.2f, 0.2f, 0.2f, 1.f); // couleur par defaut de la fenetre
31
32 glClearDepth(1.f); // profondeur par defaut
33 glDepthFunc(GL_LESS); // ztest, conserver l'intersection la plus proche de la camera
34 glEnable(GL_DEPTH_TEST); // activer le ztest
35
36 return 0; // ras, pas d'erreur
37 }
Mesh::bounds
void bounds(Point &pmin, Point &pmax)
renvoie min et max les coordonnees des extremites des positions des sommets de l'objet (boite engloba...
Definition: mesh.cpp:153
read_texture
GLuint read_texture(const int unit, const char *filename, const GLenum texel_type)
Definition: texture.cpp:98
Orbiter::lookat
void lookat(const Point &center, const float size)
observe le point center a une distance size.
Definition: orbiter.cpp:7
Point
representation d'un point 3d.
Definition: vec.h:19
read_mesh
Mesh read_mesh(const char *filename)
charge un fichier wavefront .obj et renvoie un mesh compose de triangles non indexes. utiliser glDrawArrays pour l'afficher. a detruire avec Mesh::release( ).
Definition: wavefront.cpp:8

int TP::quit | ( |  | ) |
| inline virtual

a deriver pour detruire les objets openGL.

Implements App.

Definition at line 40 of file tuto8.cpp.

41 {
42 m_objet.release();
43 glDeleteTextures(1, &m_texture);
44
45 return 0;
46 }
Mesh::release
void release()
detruit les objets openGL.
Definition: mesh.cpp:19

int TP::update | ( | const float | time,
|  | const float | delta
| ) |  |
| inline virtual

a deriver et redefinir pour animer les objets en fonction du temps.

Reimplemented from App.

Definition at line 48 of file tuto8.cpp.

49 {
50 // modifier l'orientation du cube a chaque image.
51 // time est le temps ecoule depuis le demarrage de l'application, en millisecondes,
52 // delta est le temps ecoule depuis l'affichage de la derniere image / le dernier appel a draw(), en millisecondes.
53
54 m_model= RotationY(time / 20);
55 return 0;
56 }
RotationY
Transform RotationY(const float a)
renvoie la matrice representation une rotation de a degree autour de l'axe Y.
Definition: mat.cpp:158

int TP::render | ( |  | ) |
| inline virtual

a deriver pour afficher les objets.

Implements App.

Definition at line 59 of file tuto8.cpp.

60 {
61 glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
62
63 // deplace la camera
64 int mx, my;
65 unsigned int mb= SDL_GetRelativeMouseState(&mx, &my);
66 if(mb & SDL_BUTTON(1)) // le bouton gauche est enfonce
67 m_camera.rotation(mx, my);
68 else if(mb & SDL_BUTTON(3)) // le bouton droit est enfonce
69 m_camera.move(mx);
70 else if(mb & SDL_BUTTON(2)) // le bouton du milieu est enfonce
71 m_camera.translation((float) mx / (float) window_width(), (float) my / (float) window_height());
72
73 draw(m_objet, m_model, m_camera, m_texture);
74
75 return 1;
76 }
Orbiter::move
void move(const float z)
rapproche / eloigne la camera du centre.
Definition: orbiter.cpp:33
draw
void draw(Mesh &m, const Transform &model, const Transform &view, const Transform &projection, const GLuint texture)
applique une texture a la surface de l'objet. ne fonctionne que si les coordonnees de textures sont f...
Definition: draw.cpp:6
window_width
int window_width()
renvoie la largeur de la fenetre de l'application.
Definition: window.cpp:14
Orbiter::translation
void translation(const float x, const float y)
deplace le centre / le point observe.
Definition: orbiter.cpp:27
Orbiter::rotation
void rotation(const float x, const float y)
change le point de vue / la direction d'observation.
Definition: orbiter.cpp:21
window_height
int window_height()
renvoie la hauteur de la fenetre de l'application.
Definition: window.cpp:18

int TP::init | ( |  | ) |
| inline virtual

a deriver pour creer les objets openGL.

Implements App.

Definition at line 55 of file tuto_transform.cpp.

56 {
57 // volume visible par une camera, un cube -1 1
58 m_frustum= read_mesh("data/frustum.obj");
59
60 // grille / plan de reference
61 m_grid.create(GL_LINES);
62 for(int x= 0; x < 10; x++)
63 {
64 float px= (float) x - 5.f + 0.5f;
65 m_grid.vertex(px, 0, -4.5f);
66 m_grid.vertex(px, 0, 4.5f);
67 }
68
69 for(int z= 0; z < 10; z++)
70 {
71 float pz= (float) z - 5.f + 0.5f;
72 m_grid.vertex(-4.5f, 0, pz);
73 m_grid.vertex(4.5f, 0, pz);
74 }
75
76 // charge un objet a afficher
77 m_objet= read_mesh("data/bigguy.obj");
78
79 // conserve (les extremites de) sa boite englobante
80 m_objet.bounds(m_pmin, m_pmax);
81 m_camera.lookat(m_pmin, m_pmax);
82 //~ m_camera.lookat(Point(), 10);
83
84 m_objet.default_color(Green());
85
86 // etat openGL par defaut
87 glClearColor(0.2f, 0.2f, 0.2f, 1.f); // couleur par defaut de la fenetre
88
89 glClearDepth(1.f); // profondeur par defaut
90 glDepthFunc(GL_LESS); // ztest, conserver l'intersection la plus proche de la camera
91 glEnable(GL_DEPTH_TEST); // activer le ztest
92
93 return 0; // ras, pas d'erreur
94 }
Mesh::bounds
void bounds(Point &pmin, Point &pmax)
renvoie min et max les coordonnees des extremites des positions des sommets de l'objet (boite engloba...
Definition: mesh.cpp:153
Mesh::vertex
unsigned int vertex(const vec3 &p)
insere un sommet de position p, et ses attributs (s'ils sont definis par color(), texcoord()...
Definition: mesh.cpp:56
Mesh::create
int create(const GLenum primitives)
construit les objets openGL.
Definition: mesh.cpp:13
Orbiter::lookat
void lookat(const Point &center, const float size)
observe le point center a une distance size.
Definition: orbiter.cpp:7
Green
Color Green()
utilitaire. renvoie une couleur verte.
Definition: color.cpp:20
read_mesh
Mesh read_mesh(const char *filename)
charge un fichier wavefront .obj et renvoie un mesh compose de triangles non indexes. utiliser glDrawArrays pour l'afficher. a detruire avec Mesh::release( ).
Definition: wavefront.cpp:8
Mesh::default_color
Color default_color() const
renvoie la couleur par defaut du mesh, utilisee si les sommets n'ont pas de couleur associee...
Definition: mesh.h:105

int TP::quit | ( |  | ) |
| inline virtual

a deriver pour detruire les objets openGL.

Implements App.

Definition at line 97 of file tuto_transform.cpp.

98 {
99 m_frustum.release();
100 m_grid.release();
101 m_objet.release();
102 glDeleteTextures(1, &m_texture);
103
104 return 0;
105 }
Mesh::release
void release()
detruit les objets openGL.
Definition: mesh.cpp:19

int TP::update | ( | const float | time,
|  | const float | delta
| ) |  |
| inline virtual

a deriver et redefinir pour animer les objets en fonction du temps.

Reimplemented from App.

Definition at line 107 of file tuto_transform.cpp.

108 {
109 // modifier l'orientation du cube a chaque image.
110 // time est le temps ecoule depuis le demarrage de l'application, en millisecondes,
111 // delta est le temps ecoule depuis l'affichage de la derniere image / le dernier appel a draw(), en millisecondes.
112
113 m_model= RotationY(time / 20);
114 return 0;
115 }
RotationY
Transform RotationY(const float a)
renvoie la matrice representation une rotation de a degree autour de l'axe Y.
Definition: mat.cpp:158

int TP::render | ( |  | ) |
| inline virtual

a deriver pour afficher les objets.

Implements App.

Definition at line 118 of file tuto_transform.cpp.

119 {
120 glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
121
122 // deplace la camera
123 int mx, my;
124 unsigned int mb= SDL_GetRelativeMouseState(&mx, &my);
125
126 if(key_state(' '))
127 {
128 // deplace la camera "normale"
129 if(mb & SDL_BUTTON(1)) // le bouton gauche est enfonce
130 m_camera.rotation((float) mx, (float) my);
131 else if(mb & SDL_BUTTON(3)) // le bouton droit est enfonce
132 m_camera.move((float) mx);
133 else if(mb & SDL_BUTTON(2)) // le bouton du milieu est enfonce
134 m_camera.translation((float) mx / (float) window_width(), (float) my / (float) window_height());
135 }
136 else
137 {
138 // deplace l'observateur
139 if(mb & SDL_BUTTON(1)) // le bouton gauche est enfonce
140 m_observer.rotation((float) mx / 10, (float) my / 10);
141 else if(mb & SDL_BUTTON(3)) // le bouton droit est enfonce
142 m_observer.move((float) mx / 10);
143 else if(mb & SDL_BUTTON(2)) // le bouton du milieu est enfonce
144 m_observer.translation((float) mx / (float) window_width(), (float) my / (float) window_height());
145 }
146
147 // affiche l'objet en rouge, si sa boite englobante n'est pas visible pour la camera.
148 if(visible(m_camera.projection((float) window_width(), (float)window_height(), 45) * m_camera.view() * m_model, m_pmin, m_pmax))
149 m_objet.default_color(Green());
150 else
151 m_objet.default_color(Red());
152
153
154 Transform view= m_observer.view();
155 Transform projection= Perspective(45, (float) window_width() / (float) window_height(), .1f, 1000.f);
156
157 static bool wireframe= false;
158 if(key_state(' '))
159 {
160 glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
161
162 // afficher le point de vue "normal"
163 draw(m_grid, m_camera);
164 draw(m_objet, m_model, m_camera);
165 }
166 else
167 {
168 if(key_state('w'))
169 {
170 clear_key_state('w');
171 wireframe= !wireframe;
172 }
173
174 if(!wireframe)
175 glPolygonMode(GL_FRONT_AND_BACK, GL_FILL);
176 else
177 glPolygonMode(GL_FRONT_AND_BACK, GL_LINE);
178
179 #if 1
180 // afficher le volume visible de la camera dans le repere monde
181 draw(m_grid, Identity(), view, projection);
182 draw(m_frustum, Inverse(m_camera.projection((float) window_width(), (float) window_height(), 45) * m_camera.view()), view, projection);
183 draw(m_objet, m_model, view, projection);
184
185 #else
186 // afficher dans le repere image
187 draw(m_grid, m_camera.projection(window_width(), window_height(), 45) * m_camera.view(), view, projection);
188 draw(m_frustum, m_camera.projection(window_width(), window_height(), 45) * m_camera.view() * Inverse(m_camera.projection(window_width(), window_height(), 45) * m_camera.view()), view, projection);
189 // remarque : ca se simplifie non ??
190 draw(m_objet, m_camera.projection(window_width(), window_height(), 45) * m_camera.view() * m_model, view, projection);
191 #endif
192 }
193
194 return 1;
195 }
clear_key_state
void clear_key_state(const SDL_Keycode key)
desactive une touche du clavier.
Definition: window.cpp:30
Orbiter::move
void move(const float z)
rapproche / eloigne la camera du centre.
Definition: orbiter.cpp:33
Identity
Transform Identity()
construit la transformation identite.
Definition: mat.cpp:103
draw
void draw(Mesh &m, const Transform &model, const Transform &view, const Transform &projection, const GLuint texture)
applique une texture a la surface de l'objet. ne fonctionne que si les coordonnees de textures sont f...
Definition: draw.cpp:6
Orbiter::view
Transform view() const
renvoie la transformation vue.
Definition: orbiter.cpp:40
window_width
int window_width()
renvoie la largeur de la fenetre de l'application.
Definition: window.cpp:14
Inverse
Transform Inverse(const Transform &m)
renvoie l'inverse de la matrice.
Definition: mat.cpp:113
Orbiter::projection
Transform projection(const float width, const float height, const float fov) const
renvoie la projection reglee pour une image d'aspect width / height, et une ouverture de fov degres...
Definition: orbiter.cpp:47
key_state
int key_state(const SDL_Keycode key)
renvoie l'etat d'une touche du clavier. cf la doc SDL2 pour les codes.
Definition: window.cpp:24
Orbiter::translation
void translation(const float x, const float y)
deplace le centre / le point observe.
Definition: orbiter.cpp:27
Perspective
Transform Perspective(const float fov, const float aspect, const float znear, const float zfar)
renvoie la matrice representant une transformation projection perspective.
Definition: mat.cpp:208
Orbiter::rotation
void rotation(const float x, const float y)
change le point de vue / la direction d'observation.
Definition: orbiter.cpp:21
window_height
int window_height()
renvoie la hauteur de la fenetre de l'application.
Definition: window.cpp:18
Transform
representation d'une transformation, une matrice 4x4, organisee par ligne / row major.
Definition: mat.h:20
Red
Color Red()
utilitaire. renvoie une couleur rouge.
Definition: color.cpp:15
Green
Color Green()
utilitaire. renvoie une couleur verte.
Definition: color.cpp:20
Mesh::default_color
Color default_color() const
renvoie la couleur par defaut du mesh, utilisee si les sommets n'ont pas de couleur associee...
Definition: mesh.h:105

int TP::init | ( |  | ) |
| inline virtual

a deriver pour creer les objets openGL.

Implements App.

Definition at line 26 of file tuto_mdi.cpp.

27 {
28 m_objet= read_mesh("data/bigguy.obj");
29 Point pmin, pmax;
30 m_objet.bounds(pmin, pmax);
31 m_camera.lookat(pmin - Vector(20, 20, 0), pmax + Vector(20, 20, 0));
32
33 m_texture = read_texture(0, "data/debug2x2red.png");
34
35 // affichage du temps de glDraw
36 m_console= create_text();
37
38 // mesure du temps gpu de glDraw
39 glGenQueries(1, &m_time_query);
40
41 // stockage des parametres du multi draw indirect, pour 25 draws
42 glGenBuffers(1, &m_indirect_buffer);
43 glBindBuffer(GL_DRAW_INDIRECT_BUFFER, m_indirect_buffer);
44 // dimensionne le buffer
45 glBufferData(GL_DRAW_INDIRECT_BUFFER, sizeof(unsigned int) * 4 * 25, NULL, GL_STREAM_DRAW);
46 // remarque : usage == stream draw, le contenu du buffer va etre modifie regulierement.
47
48 // todo comparer avec glBufferStorage
49
50 glGenBuffers(1, &m_model_buffer);
51 #if 1
52 glBindBuffer(GL_UNIFORM_BUFFER, m_model_buffer);
53 // dimensionne le buffer
54 glBufferData(GL_UNIFORM_BUFFER, sizeof(Transform) * 25, NULL, GL_STREAM_DRAW);
55 // remarque : usage == stream draw, le contenu du buffer va etre modifie regulierement.
56 #endif
57
58 // creation des vertex buffer
59 m_vao= m_objet.create_buffers(false, false, false);
60 // et du shader program
61 m_program= read_program("tutos/M2/indirect.glsl");
62 program_print_errors(m_program);
63
64 // etat openGL par defaut
65 glClearColor(0.2f, 0.2f, 0.2f, 1.f); // couleur par defaut de la fenetre
66
67 glClearDepth(1.f); // profondeur par defaut
68 glDepthFunc(GL_LESS); // ztest, conserver l'intersection la plus proche de la camera
69 glEnable(GL_DEPTH_TEST); // activer le ztest
70
71 return 0; // ras, pas d'erreur
72 }
create_text
Text create_text()
cree une console. a detruire avec release_text( ).
Definition: text.cpp:14
Mesh::bounds
void bounds(Point &pmin, Point &pmax)
renvoie min et max les coordonnees des extremites des positions des sommets de l'objet (boite engloba...
Definition: mesh.cpp:153
Mesh::create_buffers
GLuint create_buffers(const bool use_texcoord=true, const bool use_normal=true, const bool use_color=true)
Definition: mesh.cpp:196
read_texture
GLuint read_texture(const int unit, const char *filename, const GLenum texel_type)
Definition: texture.cpp:98
Vector
representation d'un vecteur 3d.
Definition: vec.h:42
program_print_errors
int program_print_errors(const GLuint program)
affiche les erreurs de compilation.
Definition: program.cpp:330
Orbiter::lookat
void lookat(const Point &center, const float size)
observe le point center a une distance size.
Definition: orbiter.cpp:7
read_program
GLuint read_program(const char *filename, const char *definitions)
Definition: program.cpp:150
Transform
representation d'une transformation, une matrice 4x4, organisee par ligne / row major.
Definition: mat.h:20
Point
representation d'un point 3d.
Definition: vec.h:19
read_mesh
Mesh read_mesh(const char *filename)
charge un fichier wavefront .obj et renvoie un mesh compose de triangles non indexes. utiliser glDrawArrays pour l'afficher. a detruire avec Mesh::release( ).
Definition: wavefront.cpp:8

int TP::quit | ( |  | ) |
| inline virtual

a deriver pour detruire les objets openGL.

Implements App.

Definition at line 74 of file tuto_mdi.cpp.

75 {
76 glDeleteQueries(1, &m_time_query);
77 glDeleteBuffers(1, &m_indirect_buffer);
78 glDeleteBuffers(1, &m_model_buffer);
79
80 release_text(m_console);
81 release_vertex_format(m_vao);
82 release_program(m_program);
83
84 m_objet.release();
85 glDeleteTextures(1, &m_texture);
86
87 return 0;
88 }
release_text
void release_text(Text &text)
detruit une console.
Definition: text.cpp:64
release_vertex_format
void release_vertex_format(const GLuint vao)
detruit le vertex array vao et les buffers associes, crees par make_vertex_buffer() et make_index_buf...
Definition: buffer.cpp:31
Mesh::release
void release()
detruit les objets openGL.
Definition: mesh.cpp:19
release_program
int release_program(const GLuint program)
detruit les shaders et le program.
Definition: program.cpp:157

int TP::update | ( | const float | time,
|  | const float | delta
| ) |  |
| inline virtual

a deriver et redefinir pour animer les objets en fonction du temps.

Reimplemented from App.

Definition at line 90 of file tuto_mdi.cpp.

91 {
92 m_model= RotationY(time / 20);
93 return 0;
94 }
RotationY
Transform RotationY(const float a)
renvoie la matrice representation une rotation de a degree autour de l'axe Y.
Definition: mat.cpp:158

int TP::render | ( |  | ) |
| inline virtual

a deriver pour afficher les objets.

Implements App.

Definition at line 96 of file tuto_mdi.cpp.

97 {
98 glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
99
100 // deplace la camera
101 int mx, my;
102 unsigned int mb= SDL_GetRelativeMouseState(&mx, &my);
103 if(mb & SDL_BUTTON(1)) // le bouton gauche est enfonce
104 m_camera.rotation(mx, my);
105 else if(mb & SDL_BUTTON(3)) // le bouton droit est enfonce
106 m_camera.move(mx);
107 else if(mb & SDL_BUTTON(2)) // le bouton du milieu est enfonce
108 m_camera.translation((float) mx / (float) window_width(), (float) my / (float) window_height());
109
110 // mesure le temps d'execution du draw
111 glBeginQuery(GL_TIME_ELAPSED, m_time_query); // pour le gpu
112 std::chrono::high_resolution_clock::time_point cpu_start= std::chrono::high_resolution_clock::now(); // pour le cpu
113
114 #if 0
115 // dessine 25 fois l'objet avec 25 draw
116 for(int y= -2; y <= 2; y++)
117 for(int x= -2; x <= 2; x++)
118 {
119 Transform t= Translation(x *20, y *20, 0);
120 draw(m_objet, t * m_model, m_camera, m_texture);
121 }
122
123 #else
124 // dessine 25 fois l'objet avec 1 seul appel a glMultiDrawIndirect
125
126 // representation des parametres d'un draw pour glMultiDrawIndirect
127 struct IndirectParam
128 {
129 unsigned int index_count;
130 unsigned int instance_count;
131 unsigned int first_index;
132 unsigned int first_instance;
133
134 IndirectParam( const unsigned int count ) : index_count(count), instance_count(1), first_index(0), first_instance(0) {}
135 };
136
137 std::vector<IndirectParam> indirect;
138 indirect.reserve(25);
139
140 // stocke aussi les transformations pour placer / orienter chaque objet
141 std::vector<Transform> model;
142 model.reserve(25);
143
144 // genere les parametres des 25 draws
145 for(int y= -2; y <= 2; y++)
146 for(int x= -2; x <= 2; x++)
147 {
148 model.push_back( Translation(x *20, y *20, 0) * m_model );
149 indirect.push_back( IndirectParam(m_objet.vertex_count()) );
150 }
151
152 //
153 glBindVertexArray(m_vao);
154 glUseProgram(m_program);
155
156 // transfere les donnees des draws dans un buffer
157 glBindBuffer(GL_DRAW_INDIRECT_BUFFER, m_indirect_buffer);
158 //~ glInvalidateBufferData(GL_DRAW_INDIRECT_BUFFER); // detruit le contenu du buffer
159 glBufferData(GL_DRAW_INDIRECT_BUFFER, sizeof(IndirectParam) * indirect.size(), NULL, GL_STREAM_DRAW); // detruit le contenu du buffer
160 glBufferSubData(GL_DRAW_INDIRECT_BUFFER, 0, sizeof(IndirectParam) * indirect.size(), &indirect.front());
161
162 #if 1
163 // transfere les transformations dans un uniform buffer
164 glBindBufferBase(GL_UNIFORM_BUFFER, 0, m_model_buffer);
165 //~ glInvalidateBufferData(GL_UNIFORM_BUFFER); // detruit le contenu du buffer
166 glBufferData(GL_UNIFORM_BUFFER, sizeof(Transform) * model.size(), NULL, GL_STREAM_DRAW); // detruit le contenu du buffer
167 glBufferSubData(GL_UNIFORM_BUFFER, 0, sizeof(Transform) * model.size(), model.front().buffer());
168 #else
169
170 // transfere les transformations dans un tableau d'uniform "classique"
171 GLint location= glGetUniformLocation(m_program, "model");
172 glUniformMatrix4fv(location, model.size(), GL_TRUE, model.front().buffer());
173 #endif
174
175 program_uniform(m_program, "vpMatrix", m_camera.projection(window_width(), window_height(), 45) * m_camera.view());
176 program_uniform(m_program, "viewMatrix", m_camera.view());
177
178 glMultiDrawArraysIndirect(m_objet.primitives(), 0, indirect.size(), 0);
179 #endif
180
181 std::chrono::high_resolution_clock::time_point cpu_stop= std::chrono::high_resolution_clock::now();
182 long long int cpu_time= std::chrono::duration_cast<std::chrono::nanoseconds>(cpu_stop - cpu_start).count();
183
184 glEndQuery(GL_TIME_ELAPSED);
185
186 // recupere le resultat de la requete gpu
187 GLint64 gpu_time= 0;
188 glGetQueryObjecti64v(m_time_query, GL_QUERY_RESULT, &gpu_time);
189
190 // affiche le temps mesure
191 clear(m_console);
192 printf(m_console, 0, 0, "cpu %02dms %03dus", (int) (cpu_time / 1000000), (int) ((cpu_time / 1000) % 1000));
193 printf(m_console, 0, 1, "gpu %02dms %03dus", (int) (gpu_time / 1000000), (int) ((gpu_time / 1000) % 1000));
194
195 // affiche le texte
196 draw(m_console, window_width(), window_height());
197
198 printf("cpu %02dms %03dus ", (int) (cpu_time / 1000000), (int) ((cpu_time / 1000) % 1000));
199 printf("gpu %02dms %03dus\n", (int) (gpu_time / 1000000), (int) ((gpu_time / 1000) % 1000));
200
201 return 1;
202 }
Orbiter::move
void move(const float z)
rapproche / eloigne la camera du centre.
Definition: orbiter.cpp:33
program_uniform
void program_uniform(const GLuint program, const char *uniform, const unsigned int v)
affecte une valeur a un uniform du shader program. uint.
Definition: uniforms.cpp:68
draw
void draw(Mesh &m, const Transform &model, const Transform &view, const Transform &projection, const GLuint texture)
applique une texture a la surface de l'objet. ne fonctionne que si les coordonnees de textures sont f...
Definition: draw.cpp:6
Orbiter::view
Transform view() const
renvoie la transformation vue.
Definition: orbiter.cpp:40
window_width
int window_width()
renvoie la largeur de la fenetre de l'application.
Definition: window.cpp:14
Orbiter::projection
Transform projection(const float width, const float height, const float fov) const
renvoie la projection reglee pour une image d'aspect width / height, et une ouverture de fov degres...
Definition: orbiter.cpp:47
Translation
Transform Translation(const Vector &v)
renvoie la matrice representant une translation par un vecteur.
Definition: mat.cpp:132
Orbiter::translation
void translation(const float x, const float y)
deplace le centre / le point observe.
Definition: orbiter.cpp:27
printf
void printf(Text &text, const int px, const int py, const char *format,...)
affiche un texte a la position x, y. meme utilisation que printf().
Definition: text.cpp:140
Orbiter::rotation
void rotation(const float x, const float y)
change le point de vue / la direction d'observation.
Definition: orbiter.cpp:21
window_height
int window_height()
renvoie la hauteur de la fenetre de l'application.
Definition: window.cpp:18
Transform
representation d'une transformation, une matrice 4x4, organisee par ligne / row major.
Definition: mat.h:20
clear
void clear(Text &text)
efface le contenu de la console.
Definition: text.cpp:72
Mesh::vertex_count
int vertex_count() const
renvoie le nombre de sommets.
Definition: mesh.h:190

int TP::init | ( |  | ) |
| inline virtual

a deriver pour creer les objets openGL.

Implements App.

Definition at line 24 of file tuto_time.cpp.

25 {
26 // charge un objet et une texture a afficher
27 // mode 0 & 1
28 m_objet= read_mesh("data/bigguy.obj");
29 Point pmin, pmax;
30 m_objet.bounds(pmin, pmax);
31 m_camera.lookat(pmin - Vector(20, 20, 0), pmax + Vector(20, 20, 0));
32
33 m_texture= read_texture(0, "data/debug2x2red.png");
34
35 // mode 2
36 // configure le vertex array / format de sommet
37 glGenVertexArrays(1, &m_vao);
38 glBindVertexArray(m_vao);
39
40 // buffer : positions + normals
41 glGenBuffers(1, &m_vertex_buffer);
42 glBindBuffer(GL_ARRAY_BUFFER, m_vertex_buffer);
43 glBufferData(GL_ARRAY_BUFFER, m_objet.vertex_buffer_size() + m_objet.normal_buffer_size(), 0, GL_STATIC_DRAW);
44
45 // transfere les positions des sommets
46 glBufferSubData(GL_ARRAY_BUFFER, /* offset */ 0, /* size */ m_objet.vertex_buffer_size(), /* data */ m_objet.vertex_buffer());
47 // configure l'attribut 0, vec3 position
48 glVertexAttribPointer(0, 3, GL_FLOAT, GL_FALSE, /* stride */ 0, /* offset */ 0);
49 glEnableVertexAttribArray(0);
50
51 // transfere les normales des sommets
52 glBufferSubData(GL_ARRAY_BUFFER, /* offset */ m_objet.vertex_buffer_size(), /* size */ m_objet.normal_buffer_size(), /* data */ m_objet.normal_buffer());
53 // configure l'attribut 2, vec3 normal
54 glVertexAttribPointer(2, 3, GL_FLOAT, GL_FALSE, /* stride */ 0, /* offset */ (const GLvoid *) m_objet.vertex_buffer_size());
55 glEnableVertexAttribArray(2);
56
57 m_vertex_count= m_objet.vertex_count();
58
59 m_program= read_program("tutos/M2/instance.glsl");
60 program_print_errors(m_program);
61
62 // nettoyage
63 glBindVertexArray(0);
64 glBindBuffer(GL_ARRAY_BUFFER, 0);
65
66 // mesure du temps gpu de glDraw
67 glGenQueries(1, &m_time_query);
68
69 // affichage du temps dans la fenetre
70 m_console= create_text();
71
72 // etat openGL par defaut
73 glClearColor(0.2f, 0.2f, 0.2f, 1.f); // couleur par defaut de la fenetre
74
75 glClearDepth(1.f); // profondeur par defaut
76 glDepthFunc(GL_LESS); // ztest, conserver l'intersection la plus proche de la camera
77 glEnable(GL_DEPTH_TEST); // activer le ztest
78
79 return 0; // ras, pas d'erreur
80 }
Mesh::normal_buffer
const float * normal_buffer() const
renvoie l'adresse de la normale du premier sommet. par convention, la normale est un vec3...
Definition: mesh.h:200
create_text
Text create_text()
cree une console. a detruire avec release_text( ).
Definition: text.cpp:14
Mesh::vertex_buffer
const float * vertex_buffer() const
renvoie l'adresse de la position du premier sommet. permet de construire les vertex buffers openGL...
Definition: mesh.h:195
Mesh::bounds
void bounds(Point &pmin, Point &pmax)
renvoie min et max les coordonnees des extremites des positions des sommets de l'objet (boite engloba...
Definition: mesh.cpp:153
Mesh::normal_buffer_size
std::size_t normal_buffer_size() const
renvoie la longueur (en octets) du normal buffer.
Definition: mesh.h:202
Mesh::vertex_buffer_size
std::size_t vertex_buffer_size() const
renvoie la longueur (en octets) du vertex buffer.
Definition: mesh.h:197
read_texture
GLuint read_texture(const int unit, const char *filename, const GLenum texel_type)
Definition: texture.cpp:98
Vector
representation d'un vecteur 3d.
Definition: vec.h:42
program_print_errors
int program_print_errors(const GLuint program)
affiche les erreurs de compilation.
Definition: program.cpp:330
Orbiter::lookat
void lookat(const Point &center, const float size)
observe le point center a une distance size.
Definition: orbiter.cpp:7
read_program
GLuint read_program(const char *filename, const char *definitions)
Definition: program.cpp:150
Point
representation d'un point 3d.
Definition: vec.h:19
Mesh::vertex_count
int vertex_count() const
renvoie le nombre de sommets.
Definition: mesh.h:190
read_mesh
Mesh read_mesh(const char *filename)
charge un fichier wavefront .obj et renvoie un mesh compose de triangles non indexes. utiliser glDrawArrays pour l'afficher. a detruire avec Mesh::release( ).
Definition: wavefront.cpp:8

int TP::quit | ( |  | ) |
| inline virtual

a deriver pour detruire les objets openGL.

Implements App.

Definition at line 82 of file tuto_time.cpp.

83 {
84 glDeleteQueries(1, &m_time_query);
85
86 release_text(m_console);
87 m_objet.release();
88 glDeleteTextures(1, &m_texture);
89
90 return 0;
91 }
release_text
void release_text(Text &text)
detruit une console.
Definition: text.cpp:64
Mesh::release
void release()
detruit les objets openGL.
Definition: mesh.cpp:19

int TP::update | ( | const float | time,
|  | const float | delta
| ) |  |
| inline virtual

a deriver et redefinir pour animer les objets en fonction du temps.

Reimplemented from App.

Definition at line 93 of file tuto_time.cpp.

94 {
95 m_model= RotationY(time / 20);
96 return 0;
97 }
RotationY
Transform RotationY(const float a)
renvoie la matrice representation une rotation de a degree autour de l'axe Y.
Definition: mat.cpp:158

int TP::render | ( |  | ) |
| inline virtual

a deriver pour afficher les objets.

Implements App.

Definition at line 99 of file tuto_time.cpp.

100 {
101 glClear(GL_COLOR_BUFFER_BIT | GL_DEPTH_BUFFER_BIT);
102
103 // deplace la camera
104 int mx, my;
105 unsigned int mb= SDL_GetRelativeMouseState(&mx, &my);
106 if(mb & SDL_BUTTON(1)) // le bouton gauche est enfonce
107 m_camera.rotation(mx, my);
108 else if(mb & SDL_BUTTON(3)) // le bouton droit est enfonce
109 m_camera.move(mx);
110 else if(mb & SDL_BUTTON(2)) // le bouton du milieu est enfonce
111 m_camera.translation((float) mx / (float) window_width(), (float) my / (float) window_height());
112
113 // mesure le temps d'execution du draw pour le gpu
114 glBeginQuery(GL_TIME_ELAPSED, m_time_query);
115
116 // mesure le temps d'execution du draw pour le cpu
117 // utilise std::chrono pour mesurer le temps cpu
118 std::chrono::high_resolution_clock::time_point cpu_start= std::chrono::high_resolution_clock::now();
119
120 static int mode= 0;
121 if(key_state(' '))
122 {
123 clear_key_state(' ');
124 mode= (mode + 1) % 3;
125 }
126
127 if(mode == 0)
128 {
129 // dessine 1 objet
130 draw(m_objet, m_model, m_camera, m_texture);
131 }
132 else if(mode == 1)
133 {
134 // dessine 25 fois l'objet sur une grille
135 for(int y= -2; y <= 2; y++)
136 for(int x= -2; x <= 2; x++)
137 {
138 Transform t= Translation(x *20, y *20, 0);
139 draw(m_objet, t * m_model, m_camera, m_texture);
140 }
141 }
142 else if(mode == 2)
143 {
144 // dessine 25 copies de l'objet sur une grille avec un seul glDrawArrayInstanced( ), c'est le vertex shader qui calcule la translation
145 // cf gl_InstanceID qui contient l'indice de la copie
146 glBindVertexArray(m_vao);
147 glUseProgram(m_program);
148
149 Transform m= m_model;
150 Transform v= m_camera.view();
151 Transform p= m_camera.projection(window_width(), window_height(), 45);
152 Transform mvp= p * v * m;
153 Transform mv= v * m;
154
155 program_uniform(m_program, "mvpMatrix", mvp);
156 program_uniform(m_program, "normalMatrix", mv.normal());
157
158 glDrawArraysInstanced(GL_TRIANGLES, 0, m_vertex_count, 25);
159 }
160
161 std::chrono::high_resolution_clock::time_point cpu_stop= std::chrono::high_resolution_clock::now();
162 // conversion desmesures en duree...
163 long long int cpu_time= std::chrono::duration_cast<std::chrono::nanoseconds>(cpu_stop - cpu_start).count();
164
165 glEndQuery(GL_TIME_ELAPSED);
166
167 /* recuperer le resultat de la requete time_elapsed, il faut attendre que le gpu ait fini de dessiner...
168 utilise encore std::chrono pour mesurer le temps d'attente.
169 */
170 std::chrono::high_resolution_clock::time_point wait_start= std::chrono::high_resolution_clock::now();
171
172 // attendre le resultat de la requete
173 GLint64 gpu_time= 0;
174 glGetQueryObjecti64v(m_time_query, GL_QUERY_RESULT, &gpu_time);
175
176 std::chrono::high_resolution_clock::time_point wait_stop= std::chrono::high_resolution_clock::now();
177 long long int wait_time= std::chrono::duration_cast<std::chrono::nanoseconds>(wait_stop - wait_start).count();
178
179 // affiche le temps mesure, et formate les valeurs... c'est un peu plus lisible.
180 clear(m_console);
181 if(mode == 0) printf(m_console, 0, 0, "mode 0 : 1 draw");
182 if(mode == 1) printf(m_console, 0, 0, "mode 1 : 25 draws");
183 if(mode == 2) printf(m_console, 0, 0, "mode 2 : 1 draw / 25 instances");
184 printf(m_console, 0, 1, "cpu %02dms %03dus", (int) (cpu_time / 1000000), (int) ((cpu_time / 1000) % 1000));
185 printf(m_console, 0, 2, "gpu %02dms %03dus", (int) (gpu_time / 1000000), (int) ((gpu_time / 1000) % 1000));
186 printf(m_console, 0, 3, "wait %02dms %03dus", (int) (wait_time / 1000000), (int) ((wait_time / 1000) % 1000));
187
188 // affiche le texte dans la fenetre de l'application, utilise console.h
189 draw(m_console, window_width(), window_height());
190
191 // affiche le temps dans le terminal
192 printf("cpu %02dms %03dus ", (int) (cpu_time / 1000000), (int) ((cpu_time / 1000) % 1000));
193 printf("gpu %02dms %03dus\n", (int) (gpu_time / 1000000), (int) ((gpu_time / 1000) % 1000));
194
195 return 1;
196 }
Transform::normal
Transform normal() const
renvoie la transformation a appliquer aux normales d'un objet transforme par la matrice m...
Definition: mat.cpp:97
clear_key_state
void clear_key_state(const SDL_Keycode key)
desactive une touche du clavier.
Definition: window.cpp:30
Orbiter::move
void move(const float z)
rapproche / eloigne la camera du centre.
Definition: orbiter.cpp:33
program_uniform
void program_uniform(const GLuint program, const char *uniform, const unsigned int v)
affecte une valeur a un uniform du shader program. uint.
Definition: uniforms.cpp:68
draw
void draw(Mesh &m, const Transform &model, const Transform &view, const Transform &projection, const GLuint texture)
applique une texture a la surface de l'objet. ne fonctionne que si les coordonnees de textures sont f...
Definition: draw.cpp:6
Orbiter::view
Transform view() const
renvoie la transformation vue.
Definition: orbiter.cpp:40
window_width
int window_width()
renvoie la largeur de la fenetre de l'application.
Definition: window.cpp:14
Orbiter::projection
Transform projection(const float width, const float height, const float fov) const
renvoie la projection reglee pour une image d'aspect width / height, et une ouverture de fov degres...
Definition: orbiter.cpp:47
key_state
int key_state(const SDL_Keycode key)
renvoie l'etat d'une touche du clavier. cf la doc SDL2 pour les codes.
Definition: window.cpp:24
Translation
Transform Translation(const Vector &v)
renvoie la matrice representant une translation par un vecteur.
Definition: mat.cpp:132
Orbiter::translation
void translation(const float x, const float y)
deplace le centre / le point observe.
Definition: orbiter.cpp:27
printf
void printf(Text &text, const int px, const int py, const char *format,...)
affiche un texte a la position x, y. meme utilisation que printf().
Definition: text.cpp:140
Orbiter::rotation
void rotation(const float x, const float y)
change le point de vue / la direction d'observation.
Definition: orbiter.cpp:21
window_height
int window_height()
renvoie la hauteur de la fenetre de l'application.
Definition: window.cpp:18
Transform
representation d'une transformation, une matrice 4x4, organisee par ligne / row major.
Definition: mat.h:20
clear
void clear(Text &text)
efface le contenu de la console.
Definition: text.cpp:72

The documentation for this class was generated from the following files:

- tutos/tuto7.cpp
- tutos/tuto8.cpp
- tutos/tuto_transform.cpp
- tutos/M2/tuto_mdi.cpp
- tutos/M2/tuto_time.cpp